Attribute VB_Name = "Module1"
Option Explicit

Type POINTAPI
   x As Long
   y As Long
End Type


Type MSG
   hWnd As Long
   message As Long
   wParam As Long
   lParam As Long
   time As Long
   pt As POINTAPI
End Type

Public Declare Sub DragAcceptFiles Lib "shell32.dll" _
  (ByVal hWnd As Long, ByVal fAccept As Long)

Public Declare Sub DragFinish Lib "shell32.dll" _
  (ByVal hDrop As Long)

Public Declare Function DragQueryFile Lib "shell32.dll" Alias "DragQueryFileA" _
  (ByVal hDrop As Long, ByVal UINT As Long, _
   ByVal lpStr As String, ByVal ch As Long) As Long

Public Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" _
  (lpMsg As MSG, ByVal hWnd As Long, ByVal wMsgFilterMin As Long, _
   ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long

Public Const PM_NOREMOVE = &H0
Public Const PM_NOYIELD = &H2
Public Const PM_REMOVE = &H1
Public Const WM_DROPFILES = &H233

Public Sub ChercheFichiersDeposes()
   
'Cette procdure regarde les messages WM_DROPFILES

Dim FichiersDeposesMessage As MSG   'Msg Type
Dim FichiersDeposes As Boolean      'Est mis  TRUE si des fichiers sont dposes
Dim hDrop As Long                   'Pointer to the dropped file structure
Dim NomFichier As String * 128      'Le nom du fichier dpos
Dim NombreFichiersDeposes As Long   'Nombre de fichiers dposs
Dim Numfichier As Long              'Numro du fichier courant
Dim Ret As Long

'Boucle qui cherche en permanence les fichiers dposs

Do
   
    'Regarde si il y a des messages de fichiers dposs
    FichiersDeposes = PeekMessage(FichiersDeposesMessage, 0, _
                        WM_DROPFILES, WM_DROPFILES, PM_REMOVE Or PM_NOYIELD)

    If FichiersDeposes Then
      
        'rcupre le pointeur vers la "structure" des fichiers dposes (je sais pas comment il faut traduire ! : get the pointer to the dropped file structure
        hDrop = FichiersDeposesMessage.wParam
      
        'rcupre le nombre de fichiers dposs
        NombreFichiersDeposes = DragQueryFile(hDrop, True, NomFichier, 127)

        'pour chaque fichier
        For Numfichier = 1 To NombreFichiersDeposes
          
            'rcupre le nom du fichier
            Ret = DragQueryFile(hDrop, Numfichier - 1, NomFichier, 127)
            
            'Le NomFichier est le chemin complet du fichier
            Form1.Label1 = LTrim$(Str$(NombreFichiersDeposes))
            Form1.List1.AddItem NomFichier

       Next Numfichier
      
      'we are now done with the structure, tell windows to discard it
      'dit  Windows qu'on a fini avec la "structure"
       DragFinish (hDrop)

    End If

'pour ne pas trop accaparer toutes les ressources
DoEvents

Loop    'referme la boucle  l'infini


End Sub
Sub Main()
  

'Pour que tout marche normalement, il faut que l'excution commence
'dans la procdure Main (Sub Main)
'Faites attention  bien changer la procdure de dmarrage
'dans les options du projet

Form1.Show

'Ceci doit tre la dernire ligne de cette procdure. Mettez donc le
'code avant.

ChercheFichiersDeposes

End Sub


